// USB7SEGDlg.cpp : implementation file
//

#include "stdafx.h"
#include "USB7SEG.h"
#include "USB7SEGDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUSB7SEGDlg dialog

CUSB7SEGDlg::CUSB7SEGDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSB7SEGDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSB7SEGDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSB7SEGDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSB7SEGDlg)
	DDX_Control(pDX, IDC_SHIFT, m_ShiftCheck);
	DDX_Control(pDX, IDC_DEVICE_LIST, m_DeviceList);
	DDX_Control(pDX, IDC_COMBO1, m_Combo1);
	DDX_Control(pDX, IDC_REFRESH, m_Refresh);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSB7SEGDlg, CDialog)
	//{{AFX_MSG_MAP(CUSB7SEGDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_CBN_SELCHANGE(IDC_DEVICE_LIST, OnSelchangeDeviceList)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_SHIFT, OnShift)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSB7SEGDlg message handlers

BOOL CUSB7SEGDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_Refresh.SetIcon(theApp.LoadIcon(IDI_JOYSTICK));
	
	m_DeviceList.AddString("No Devices Detected");
	m_DeviceList.SetCurSel(0);
	m_DeviceList.SetItemData(0, 0);

	m_Combo1.SetCurSel(0);
	m_Buffer[0] = 0;
	m_Buffer[1] = 0;

	m_pDeviceInfo = (CEdit *)GetDlgItem(IDC_DEVINFO);

	m_DevCnt = 0;

	OnRefresh();
	OnSelchangeCombo1(); // update display on startup

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSB7SEGDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSB7SEGDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUSB7SEGDlg::OnRefresh() 
{
	CString str;
	int nIndex;
	UINT DevCntTemp = 0;

	m_DeviceList.ResetContent();

	m_DevCnt = 0;

	// Detect Plasma-Lite V2 + NITRO class devices
	if (DetectDevice(&DevCntTemp, &DeviceList[m_DevCnt], PIDC_PLASMA_LITE_V2, DT_DEVICES)) {
		m_DevCnt += DevCntTemp;
	}

	// Detect NITRO-SLG class devices
	if (DetectDevice(&DevCntTemp, &DeviceList[m_DevCnt], PIDC_NITRO_SLG, DT_HID)) {
		m_DevCnt += DevCntTemp;
	}

	// get all port status data if required
//	for (i = 0; i < m_DevCnt; i++) {
//		RetrieveStatus(&DeviceList[i], &DeviceStatus[i]);
//	}

	if (m_DevCnt == 0) {
		m_pDeviceInfo->SetWindowText(_T("No compatible devices detected!"));
		m_DeviceList.AddString("No Devices Detected");
		m_DeviceList.SetCurSel(0);
		m_DeviceList.SetItemData(0, 0);
	}

	// Add device to combo list if Plasma-Lite V2 or NITRO-SLG class only.
	for (UINT i = 0; i < m_DevCnt; i++) {
		str.Format("%s - %s", DeviceList[i].DeviceName, DeviceList[i].SerialNum);
		nIndex = m_DeviceList.AddString(str);
		m_DeviceList.SetItemData(nIndex, i);

		// Display Device info
		DeviceInfo(nIndex);
	}

	m_DeviceList.SetCurSel(0);
	m_DeviceIndex = m_DeviceList.GetItemData(0);
}

void CUSB7SEGDlg::OnSelchangeCombo1() 
{
	if (m_DevCnt > 0) {
		m_Buffer[0] = (UCHAR)m_Combo1.GetCurSel();
		
		Write7Segment(&DeviceList[m_DeviceIndex], m_Buffer);
	}
}

void CUSB7SEGDlg::OnShift() 
{
	if (m_DevCnt > 0) {
		m_Buffer[1] = (UCHAR)m_ShiftCheck.GetCheck();
		Write7Segment(&DeviceList[m_DeviceIndex], m_Buffer);
	}	
}

void CUSB7SEGDlg::OnSelchangeDeviceList() 
{
	m_DeviceIndex = m_DeviceList.GetItemData(m_DeviceList.GetCurSel());
	if (m_DevCnt > 0)
		DeviceInfo(m_DeviceIndex);
}

void CUSB7SEGDlg::DeviceInfo(int nIndex)
{
	CString str1, str2, str3, str4, str5, str6, str7;

	// Display Device info
	str1.Format("Device: %d\r\n", nIndex+1);
	str2.Format("  Device Type: %s\r\n", DeviceList[nIndex].DeviceName);
	str3.Format("  Vendor ID: 0x%x\r\n", DeviceList[nIndex].VendorID);
	str4.Format("  Product ID: 0x%x\r\n", DeviceList[nIndex].ProductID);
	str5.Format("  Firmware Version: %d.%d%d\r\n", 
		(((int)(DeviceList[nIndex].VersionNumber & 0xF000)>>12) * 10) + 
		((DeviceList[nIndex].VersionNumber & 0x0F00)>>8),
		(DeviceList[nIndex].VersionNumber & 0x00F0)>>4,
		DeviceList[nIndex].VersionNumber & 0x000F);
	str6.Format("  Serial Num: %s\r\n", DeviceList[nIndex].SerialNum);
	m_pDeviceInfo->SetWindowText(str1 + str2 + str3 + str4 + str5 + str6);
}
void CUSB7SEGDlg::OnClose() 
{
	if (m_DevCnt > 0)
		CloseDevices(m_DevCnt, DeviceList);
	
	CDialog::OnClose();
}
