// USBGLCDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "USBGLCD.h"
#include "USBGLCDDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUSBGLCDDlg dialog

CUSBGLCDDlg::CUSBGLCDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSBGLCDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSBGLCDDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSBGLCDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSBGLCDDlg)
	DDX_Control(pDX, IDC_EDIT5, m_Line5);
	DDX_Control(pDX, IDC_EDIT4, m_Line4);
	DDX_Control(pDX, IDC_EDIT3, m_Line3);
	DDX_Control(pDX, IDC_EDIT2, m_Line2);
	DDX_Control(pDX, IDC_EDIT1, m_Line1);
	DDX_Control(pDX, IDC_CLEAR, m_Clear);
	DDX_Control(pDX, IDC_BGCOLOR, m_BGColorBtn);
	DDX_Control(pDX, IDC_PORT, m_Port);
	DDX_Control(pDX, IDC_DEVICE_LIST, m_DeviceList);
	DDX_Control(pDX, IDC_REFRESH, m_Refresh);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSBGLCDDlg, CDialog)
	//{{AFX_MSG_MAP(CUSBGLCDDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_CBN_SELCHANGE(IDC_DEVICE_LIST, OnSelchangeDeviceList)
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_PORT, OnSelchangePort)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_BN_CLICKED(IDC_BGCOLOR, OnBgcolor)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_EN_CHANGE(IDC_EDIT2, OnChangeEdit2)
	ON_EN_CHANGE(IDC_EDIT3, OnChangeEdit3)
	ON_EN_CHANGE(IDC_EDIT4, OnChangeEdit4)
	ON_EN_CHANGE(IDC_EDIT5, OnChangeEdit5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBGLCDDlg message handlers

BOOL CUSBGLCDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_Refresh.SetIcon(theApp.LoadIcon(IDI_JOYSTICK));
	
	m_DeviceList.AddString("No Devices Detected");
	m_DeviceList.SetCurSel(0);
	m_DeviceList.SetItemData(0, 0);

	m_pDeviceInfo = (CEdit *)GetDlgItem(IDC_DEVINFO);

	m_Port.SetCurSel(0);
	m_nPort = 0;
	m_DevCnt = 0;
	m_BGColor = 0;

	m_Line1.SetLimitText(24);
	m_Line2.SetLimitText(24);
	m_Line3.SetLimitText(24);
	m_Line4.SetLimitText(24);
	m_Line5.SetLimitText(24);

	OnRefresh();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSBGLCDDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSBGLCDDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUSBGLCDDlg::OnRefresh() 
{
	CString str;
	int nIndex;

	m_DeviceList.ResetContent();
	// Add device to combo list if ElectronFlux class only.
	if (!DetectDevice(&m_DevCnt, DeviceList, PIDC_ELECTRONFLUX, DT_HID)) {
		m_DevCnt = 0;
		m_pDeviceInfo->SetWindowText(_T("No compatible devices detected!"));
		m_DeviceList.AddString("No Devices Detected");
		m_DeviceList.SetCurSel(0);
		m_DeviceList.SetItemData(0, 0);
	}

	// get all port status data if required
//	for (i = 0; i < m_DevCnt; i++) {
//		RetrieveStatus(&DeviceList[i], &DeviceStatus[i]);
//	}

	// Add device to combo list.
	for (UINT i = 0; i < m_DevCnt; i++) {
		str.Format("%s - %s", DeviceList[i].DeviceName, DeviceList[i].SerialNum);
		nIndex = m_DeviceList.AddString(str);
		m_DeviceList.SetItemData(nIndex, i);

		// Display Device info
		DeviceInfo(nIndex);
	}

	m_DeviceList.SetCurSel(0);
	m_DeviceIndex = m_DeviceList.GetItemData(0);
}

void CUSBGLCDDlg::OnSelchangeDeviceList() 
{
	m_DeviceIndex = m_DeviceList.GetItemData(m_DeviceList.GetCurSel());
	if (m_DevCnt > 0)
		DeviceInfo(m_DeviceIndex);
}

void CUSBGLCDDlg::DeviceInfo(int nIndex)
{
	CString str1, str2, str3, str4, str5, str6, str7;

	// Display Device info
	str1.Format("Device: %d\r\n", nIndex+1);
	str2.Format("  Device Type: %s\r\n", DeviceList[nIndex].DeviceName);
	str3.Format("  Vendor ID: 0x%x\r\n", DeviceList[nIndex].VendorID);
	str4.Format("  Product ID: 0x%x\r\n", DeviceList[nIndex].ProductID);
	str5.Format("  Firmware Version: %d.%d%d\r\n", 
		(((int)(DeviceList[nIndex].VersionNumber & 0xF000)>>12) * 10) + 
		((DeviceList[nIndex].VersionNumber & 0x0F00)>>8),
		(DeviceList[nIndex].VersionNumber & 0x00F0)>>4,
		DeviceList[nIndex].VersionNumber & 0x000F);
	str6.Format("  Serial Num: %s\r\n", DeviceList[nIndex].SerialNum);
	m_pDeviceInfo->SetWindowText(str1 + str2 + str3 + str4 + str5 + str6);
}

void CUSBGLCDDlg::OnClose() 
{
	if (m_DevCnt > 0)
		CloseDevices(m_DevCnt, DeviceList);
	
	CDialog::OnClose();
}

void CUSBGLCDDlg::OnSelchangePort() 
{
	m_nPort = (UCHAR)m_Port.GetCurSel();
}

void CUSBGLCDDlg::OnBgcolor() 
{
	m_BGColor = (UCHAR)m_BGColorBtn.GetCheck();

    CmdGLCD (&DeviceList[m_DeviceIndex], m_nPort, m_BGColor, GLCD_BGCOLOR);
}

void CUSBGLCDDlg::OnClear() 
{
	m_Line1.SetSel(0, -1);
	m_Line1.Clear();
	m_Line2.SetSel(0, -1);
	m_Line2.Clear();
	m_Line3.SetSel(0, -1);
	m_Line3.Clear();
	m_Line4.SetSel(0, -1);
	m_Line4.Clear();
	m_Line5.SetSel(0, -1);
	m_Line5.Clear();
	CmdGLCD (&DeviceList[m_DeviceIndex], m_nPort, m_BGColor, GLCD_CLEAR);
}

void CUSBGLCDDlg::OnChangeEdit1()
{ 
	UpdateGLCD(0, &m_Line1);
}

void CUSBGLCDDlg::OnChangeEdit2() 
{
	UpdateGLCD(1, &m_Line2);
}

void CUSBGLCDDlg::OnChangeEdit3() 
{
	UpdateGLCD(2, &m_Line3);
}

void CUSBGLCDDlg::OnChangeEdit4() 
{
	UpdateGLCD(3, &m_Line4);
}

void CUSBGLCDDlg::OnChangeEdit5() 
{
	UpdateGLCD(4, &m_Line5);
}

void CUSBGLCDDlg::UpdateGLCD(UCHAR nLine, CEdit *pLine)
{
	char DataBuffer[25];

	pLine->GetWindowText(DataBuffer, 25);
    for (int i = pLine->GetWindowTextLength(); i < 24; i++)
        DataBuffer[i] = ' ';

	WriteGLCD(&DeviceList[m_DeviceIndex], m_nPort, nLine, 1, m_BGColor, &DataBuffer[0]);
}
