// USBLATCHEDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "USBLATCHED.h"
#include "USBLATCHEDDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUSBLATCHEDDlg dialog

CUSBLATCHEDDlg::CUSBLATCHEDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSBLATCHEDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSBLATCHEDDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSBLATCHEDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSBLATCHEDDlg)
	DDX_Control(pDX, IDC_LEVEL, m_Level);
	DDX_Control(pDX, IDC_SLIDER1, m_Slider1);
	DDX_Control(pDX, IDC_PORT, m_Port);
	DDX_Control(pDX, IDC_DEVICE_LIST, m_DeviceList);
	DDX_Control(pDX, IDC_REFRESH, m_Refresh);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSBLATCHEDDlg, CDialog)
	//{{AFX_MSG_MAP(CUSBLATCHEDDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_CBN_SELCHANGE(IDC_DEVICE_LIST, OnSelchangeDeviceList)
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_PORT, OnSelchangePort)
	ON_WM_DESTROY()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_BUTTON_FIRST, IDC_BUTTON_LAST, OnButtonClicked)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBLATCHEDDlg message handlers

BOOL CUSBLATCHEDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CString str;

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_Refresh.SetIcon(theApp.LoadIcon(IDI_JOYSTICK));
	
	m_DeviceList.AddString("No Devices Detected");
	m_DeviceList.SetCurSel(0);
	m_DeviceList.SetItemData(0, 0);

	m_pDeviceInfo = (CEdit *)GetDlgItem(IDC_DEVINFO);

	m_Port.SetCurSel(0);
	m_nPort = 0;
	m_DevCnt = 0;

	m_Slider1.SetRange(0, 10);
	m_Slider1.SetPos(10);
	m_Level.SetWindowText("PWM Level: 10");

	// Create an array of buttons on the page. 
	m_pButtons = new CButton[64];
	int x = 30;	// start x pos of button
	int y = 150;	// start y pos of button
	CRect rectButton;
	int iCnt, nCol, nRow;
	
	iCnt = 0;
	for (nCol = 0; nCol<8; nCol++) {
		for(nRow = 0; nRow<8; nRow++) {
			rectButton.left = x;
			rectButton.top = y;
			rectButton.right = x+40;
			rectButton.bottom = y+20;
			str.Format("%d", iCnt + 1);
			m_pButtons[iCnt++].Create(	str, BS_CHECKBOX|WS_VISIBLE, 
										rectButton, this, 
										iCnt+IDC_BUTTON_FIRST);

			y += 20;
		}
		x += 45;	// start x pos of button
		y = 150;	// start y pos of button
	}

	memset(m_DataBuffer, 0, sizeof(m_DataBuffer));

	OnRefresh();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSBLATCHEDDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSBLATCHEDDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUSBLATCHEDDlg::OnRefresh() 
{
	CString str;
	int nIndex;

	m_DeviceList.ResetContent();

	// Detect ElectronFlux class devices for outputs
	m_DevCnt = 0;
	DetectDevice(&m_DevCnt, &DeviceList[m_DevCnt], PID_ELECTRONFLUX, DT_HID);

	if (m_DevCnt == 0) {
		m_pDeviceInfo->SetWindowText(_T("No compatible devices detected!"));
		m_DeviceList.AddString("No Devices Detected");
		m_DeviceList.SetCurSel(0);
		m_DeviceList.SetItemData(0, 0);
	}

	// get all port status data if required
//	for (i = 0; i < m_DevCnt; i++) {
//		RetrieveStatus(&DeviceList[i], &DeviceStatus[i]);
//	}

	// Add device to combo list if ElectronFlux class only.
	for (UINT i = 0; i < m_DevCnt; i++) {
		str.Format("%s - %s", DeviceList[i].DeviceName, DeviceList[i].SerialNum);
		nIndex = m_DeviceList.AddString(str);
		m_DeviceList.SetItemData(nIndex, i);

		// Display Device info
		DeviceInfo(nIndex);
	}

	m_DeviceList.SetCurSel(0);
	m_DeviceIndex = m_DeviceList.GetItemData(0);
}

void CUSBLATCHEDDlg::OnSelchangeDeviceList() 
{
	m_DeviceIndex = m_DeviceList.GetItemData(m_DeviceList.GetCurSel());
	if (m_DevCnt > 0)
		DeviceInfo(m_DeviceIndex);
}

void CUSBLATCHEDDlg::DeviceInfo(int nIndex)
{
	CString str1, str2, str3, str4, str5, str6, str7;

	// Display Device info
	str1.Format("Device: %d\r\n", nIndex+1);
	str2.Format("  Device Type: %s\r\n", DeviceList[nIndex].DeviceName);
	str3.Format("  Vendor ID: 0x%x\r\n", DeviceList[nIndex].VendorID);
	str4.Format("  Product ID: 0x%x\r\n", DeviceList[nIndex].ProductID);
	str5.Format("  Firmware Version: %d.%d%d\r\n", 
		(((int)(DeviceList[nIndex].VersionNumber & 0xF000)>>12) * 10) + 
		((DeviceList[nIndex].VersionNumber & 0x0F00)>>8),
		(DeviceList[nIndex].VersionNumber & 0x00F0)>>4,
		DeviceList[nIndex].VersionNumber & 0x000F);
	str6.Format("  Serial Num: %s\r\n", DeviceList[nIndex].SerialNum);
	m_pDeviceInfo->SetWindowText(str1 + str2 + str3 + str4 + str5 + str6);
}

void CUSBLATCHEDDlg::OnClose() 
{
	if (m_DevCnt > 0)
		CloseDevices(m_DevCnt, DeviceList);
	
	CDialog::OnClose();
}

void CUSBLATCHEDDlg::OnSelchangePort() 
{
	m_nPort = (UCHAR)m_Port.GetCurSel();
}

void CUSBLATCHEDDlg::OnButtonClicked(UINT nIDbutton)
{
	UCHAR bIndex;

	bIndex = UCHAR(nIDbutton - IDC_BUTTON_FIRST);
	if (m_pButtons[bIndex].GetCheck()) {
		m_pButtons[bIndex].SetCheck(false);
		m_DataBuffer[bIndex] = 0;
	} else {
		m_pButtons[bIndex].SetCheck(true);
		m_DataBuffer[bIndex] = 1;
	}

	//m_DataBuffer[bIndex] = m_pButtons[bIndex].GetCheck();
	UCHAR nLevel = (UCHAR)m_Slider1.GetPos();

	WriteLatchedOutput(&DeviceList[m_DeviceIndex], m_nPort, m_DataBuffer, nLevel);
}

void CUSBLATCHEDDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CString str;
	UCHAR nLevel;

	nLevel = (UCHAR)m_Slider1.GetPos();
	str.Format("PWM Level: %d", nLevel);
	m_Level.SetWindowText(str);

	WriteLatchedOutput(&DeviceList[m_DeviceIndex], m_nPort, m_DataBuffer, nLevel);

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CUSBLATCHEDDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	if(m_pButtons)
		delete [] m_pButtons;	
}
