// USBLCDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "USBLCD.h"
#include "USBLCDDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUSBLCDDlg dialog

CUSBLCDDlg::CUSBLCDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSBLCDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSBLCDDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSBLCDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSBLCDDlg)
	DDX_Control(pDX, IDC_LEVEL, m_Level);
	DDX_Control(pDX, IDC_SLIDER, m_Slider);
	DDX_Control(pDX, IDC_EDIT4, m_Line4);
	DDX_Control(pDX, IDC_EDIT3, m_Line3);
	DDX_Control(pDX, IDC_EDIT2, m_Line2);
	DDX_Control(pDX, IDC_EDIT1, m_Line1);
	DDX_Control(pDX, IDC_CLEAR, m_Clear);
	DDX_Control(pDX, IDC_DEVICE_LIST, m_DeviceList);
	DDX_Control(pDX, IDC_REFRESH, m_Refresh);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSBLCDDlg, CDialog)
	//{{AFX_MSG_MAP(CUSBLCDDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_CBN_SELCHANGE(IDC_DEVICE_LIST, OnSelchangeDeviceList)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_EN_CHANGE(IDC_EDIT2, OnChangeEdit2)
	ON_EN_CHANGE(IDC_EDIT3, OnChangeEdit3)
	ON_EN_CHANGE(IDC_EDIT4, OnChangeEdit4)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBLCDDlg message handlers

BOOL CUSBLCDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_Refresh.SetIcon(theApp.LoadIcon(IDI_JOYSTICK));
	
	m_DeviceList.AddString("No Devices Detected");
	m_DeviceList.SetCurSel(0);
	m_DeviceList.SetItemData(0, 0);

	m_pDeviceInfo = (CEdit *)GetDlgItem(IDC_DEVINFO);

	m_DevCnt = 0;

	m_Line1.SetLimitText(20);
	m_Line2.SetLimitText(20);
	m_Line3.SetLimitText(20);
	m_Line4.SetLimitText(20);

	m_Slider.SetRange(0, 255);
	m_Slider.SetPos(255);
	m_Level.SetWindowText("LCD Level: 255");

	OnRefresh();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSBLCDDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSBLCDDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUSBLCDDlg::OnRefresh() 
{
	CString str;
	int nIndex;
	UINT DevCntTemp = 0;

	m_DeviceList.ResetContent();

	m_DevCnt = 0;

	// Detect Plasma-Lite V2 + NITRO class devices
	if (DetectDevice(&DevCntTemp, &DeviceList[m_DevCnt], PIDC_PLASMA_LITE_V2, DT_DEVICES)) {
		m_DevCnt += DevCntTemp;
	}

	// Detect FUSION class devices
	if (DetectDevice(&DevCntTemp, &DeviceList[m_DevCnt], PIDC_FUSION, DT_DEVICES)) {
		m_DevCnt += DevCntTemp;
	}

	// Detect Nitro-SLG class devices for outputs
	if (DetectDevice(&DevCntTemp, &DeviceList[m_DevCnt], PIDC_NITRO_SLG, DT_HID)) {
		m_DevCnt += DevCntTemp;
	}

	if (m_DevCnt == 0) {
		m_pDeviceInfo->SetWindowText(_T("No compatible devices detected!"));
		m_DeviceList.AddString("No Devices Detected");
		m_DeviceList.SetCurSel(0);
		m_DeviceList.SetItemData(0, 0);
	}

	// get all port status data if required
//	for (i = 0; i < m_DevCnt; i++) {
//		RetrieveStatus(&DeviceList[i], &DeviceStatus[i]);
//	}

	// Add devices to combo list.
	for (UINT i = 0; i < m_DevCnt; i++) {
		str.Format("%s - %s", DeviceList[i].DeviceName, DeviceList[i].SerialNum);
		nIndex = m_DeviceList.AddString(str);
		m_DeviceList.SetItemData(nIndex, i);

		// Display Device info
		DeviceInfo(nIndex);
	}

	m_DeviceList.SetCurSel(0);
	m_DeviceIndex = m_DeviceList.GetItemData(0);
}

void CUSBLCDDlg::OnSelchangeDeviceList() 
{
	m_DeviceIndex = m_DeviceList.GetItemData(m_DeviceList.GetCurSel());
	if (m_DevCnt > 0)
		DeviceInfo(m_DeviceIndex);
}

void CUSBLCDDlg::DeviceInfo(int nIndex)
{
	CString str1, str2, str3, str4, str5, str6, str7;

	// Display Device info
	str1.Format("Device: %d\r\n", nIndex+1);
	str2.Format("  Device Type: %s\r\n", DeviceList[nIndex].DeviceName);
	str3.Format("  Vendor ID: 0x%x\r\n", DeviceList[nIndex].VendorID);
	str4.Format("  Product ID: 0x%x\r\n", DeviceList[nIndex].ProductID);
	str5.Format("  Firmware Version: %d.%d%d\r\n", 
		(((int)(DeviceList[nIndex].VersionNumber & 0xF000)>>12) * 10) + 
		((DeviceList[nIndex].VersionNumber & 0x0F00)>>8),
		(DeviceList[nIndex].VersionNumber & 0x00F0)>>4,
		DeviceList[nIndex].VersionNumber & 0x000F);
	str6.Format("  Serial Num: %s\r\n", DeviceList[nIndex].SerialNum);
	m_pDeviceInfo->SetWindowText(str1 + str2 + str3 + str4 + str5 + str6);
}

void CUSBLCDDlg::OnClose() 
{
	if (m_DevCnt > 0)
		CloseDevices(m_DevCnt, DeviceList);
	
	CDialog::OnClose();
}

void CUSBLCDDlg::OnClear() 
{
	m_Line1.SetSel(0, -1);
	m_Line1.Clear();
	m_Line2.SetSel(0, -1);
	m_Line2.Clear();
	m_Line3.SetSel(0, -1);
	m_Line3.Clear();
	m_Line4.SetSel(0, -1);
	m_Line4.Clear();
	ClearLCD (&DeviceList[m_DeviceIndex], 0);
}

void CUSBLCDDlg::OnChangeEdit1()
{ 
	UpdateLCD(1, &m_Line1);
}

void CUSBLCDDlg::OnChangeEdit2() 
{
	UpdateLCD(2, &m_Line2);
}

void CUSBLCDDlg::OnChangeEdit3() 
{
	UpdateLCD(3, &m_Line3);
}

void CUSBLCDDlg::OnChangeEdit4() 
{
	UpdateLCD(4, &m_Line4);
}

void CUSBLCDDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CString str;
	UCHAR nLevel;

	nLevel = (UCHAR)m_Slider.GetPos();
	str.Format("LCD Level: %d", nLevel);
	m_Level.SetWindowText(str);

	WriteLCD(&DeviceList[m_DeviceIndex], 0, 255, NULL, nLevel);

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CUSBLCDDlg::UpdateLCD(UCHAR nLine, CEdit *pLine)
{
	char DataBuffer[21];
	UCHAR nLevel;

	pLine->GetWindowText(DataBuffer, 21);
    for (int i = pLine->GetWindowTextLength(); i < 20; i++)
        DataBuffer[i] = ' ';

	nLevel = (UCHAR)m_Slider.GetPos();

	WriteLCD(&DeviceList[m_DeviceIndex], 0, nLine, DataBuffer, nLevel);
}

