// USBOUTPUTDlg.cpp : implementation file
//

#include "stdafx.h"
#include "USBOUTPUT.h"
#include "USBOUTPUTDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUSBOUTPUTDlg dialog

CUSBOUTPUTDlg::CUSBOUTPUTDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSBOUTPUTDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSBOUTPUTDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSBOUTPUTDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSBOUTPUTDlg)
	DDX_Control(pDX, IDC_PORT, m_Port);
	DDX_Control(pDX, IDC_DEVICE_LIST, m_DeviceList);
	DDX_Control(pDX, IDC_REFRESH, m_Refresh);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSBOUTPUTDlg, CDialog)
	//{{AFX_MSG_MAP(CUSBOUTPUTDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_CBN_SELCHANGE(IDC_DEVICE_LIST, OnSelchangeDeviceList)
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_PORT, OnSelchangePort)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_BUTTON_FIRST, IDC_BUTTON_LAST, OnButtonClicked)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBOUTPUTDlg message handlers

BOOL CUSBOUTPUTDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CString str;

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_Refresh.SetIcon(theApp.LoadIcon(IDI_JOYSTICK));
	
	m_DeviceList.AddString("No Devices Detected");
	m_DeviceList.SetCurSel(0);
	m_DeviceList.SetItemData(0, 0);

	m_pDeviceInfo = (CEdit *)GetDlgItem(IDC_DEVINFO);

	m_Port.SetCurSel(0);
	m_nPort = 0;
	m_DevCnt = 0;

	// Create an array of buttons on the page. 
	m_pButtons  = new CButton[15];
	int x = 30;	// start x pos of button
	int y = 120;	// start y pos of button
	CRect rectButton;
	int iCnt;
	for(int nRow = 0; nRow<8; nRow++) {
		rectButton.left = x;
		rectButton.top = y;
		rectButton.right = x+40;
		rectButton.bottom = y+15;
		str.Format("%d", nRow + 1);
		m_pButtons[nRow].Create(	str, BS_CHECKBOX|WS_VISIBLE, 
									rectButton, this, 
									nRow+IDC_BUTTON_FIRST);

		y += 20;
	}
	x += 50;
	y = 120;
	for(nRow = 0; nRow<7; nRow++) {
		rectButton.left = x;
		rectButton.top = y;
		rectButton.right = x+40;
		rectButton.bottom = y+15;
		iCnt = 8 + nRow;
		str.Format("%d ", iCnt + 1);
		m_pButtons[iCnt].Create(	str, BS_CHECKBOX|WS_VISIBLE, 
									rectButton, this, 
									iCnt+IDC_BUTTON_FIRST);

		y += 20;
	}

	memset(m_DataBuffer, 0, 15);

	OnRefresh();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSBOUTPUTDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSBOUTPUTDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUSBOUTPUTDlg::OnRefresh() 
{
	CString str;
	int nIndex;
	UINT DevCntTemp = 0;

	m_DeviceList.ResetContent();

	m_DevCnt = 0;

	// Detect Plasma-Lite V2 + NITRO class devices for outputs
	if (DetectDevice(&DevCntTemp, &DeviceList[m_DevCnt], PIDC_PLASMA_LITE_V2, DT_DEVICES)) {
		m_DevCnt += DevCntTemp;
	}

	// Detect ElectronFlux class devices for outputs
	if (DetectDevice(&DevCntTemp, &DeviceList[m_DevCnt], PIDC_ELECTRONFLUX, DT_HID)) {
		m_DevCnt += DevCntTemp;
	}

	if (m_DevCnt == 0) {
		m_pDeviceInfo->SetWindowText(_T("No compatible devices detected!"));
		m_DeviceList.AddString("No Devices Detected");
		m_DeviceList.SetCurSel(0);
		m_DeviceList.SetItemData(0, 0);
	}

	// get all port status data if required
//	for (i = 0; i < m_DevCnt; i++) {
//		RetrieveStatus(&DeviceList[i], &DeviceStatus[i]);
//	}

	// Add devices to combo list.
	for (UINT i = 0; i < m_DevCnt; i++) {
		str.Format("%s - %s", DeviceList[i].DeviceName, DeviceList[i].SerialNum);
		nIndex = m_DeviceList.AddString(str);
		m_DeviceList.SetItemData(nIndex, i);

		// Display Device info
		DeviceInfo(nIndex);
	}

	m_DeviceList.SetCurSel(0);
	m_DeviceIndex = m_DeviceList.GetItemData(0);
}

void CUSBOUTPUTDlg::OnSelchangeDeviceList() 
{
	m_DeviceIndex = m_DeviceList.GetItemData(m_DeviceList.GetCurSel());
	if (m_DevCnt > 0)
		DeviceInfo(m_DeviceIndex);
}

void CUSBOUTPUTDlg::DeviceInfo(int nIndex)
{
	CString str1, str2, str3, str4, str5, str6, str7;

	// Display Device info
	str1.Format("Device: %d\r\n", nIndex+1);
	str2.Format("  Device Type: %s\r\n", DeviceList[nIndex].DeviceName);
	str3.Format("  Vendor ID: 0x%x\r\n", DeviceList[nIndex].VendorID);
	str4.Format("  Product ID: 0x%x\r\n", DeviceList[nIndex].ProductID);
	str5.Format("  Firmware Version: %d.%d%d\r\n", 
		(((int)(DeviceList[nIndex].VersionNumber & 0xF000)>>12) * 10) + 
		((DeviceList[nIndex].VersionNumber & 0x0F00)>>8),
		(DeviceList[nIndex].VersionNumber & 0x00F0)>>4,
		DeviceList[nIndex].VersionNumber & 0x000F);
	str6.Format("  Serial Num: %s\r\n", DeviceList[nIndex].SerialNum);
	m_pDeviceInfo->SetWindowText(str1 + str2 + str3 + str4 + str5 + str6);
}

void CUSBOUTPUTDlg::OnClose() 
{
	if (m_DevCnt > 0)
		CloseDevices(m_DevCnt, DeviceList);
	
	CDialog::OnClose();
}

void CUSBOUTPUTDlg::OnSelchangePort() 
{
	m_nPort = (UCHAR)m_Port.GetCurSel();
}

void CUSBOUTPUTDlg::OnButtonClicked(UINT nIDbutton)
{
	if (m_pButtons[nIDbutton - IDC_BUTTON_FIRST].GetCheck()) {
		m_pButtons[nIDbutton - IDC_BUTTON_FIRST].SetCheck(false);
		m_DataBuffer[nIDbutton - IDC_BUTTON_FIRST].state = 0;
	} else {
		m_pButtons[nIDbutton - IDC_BUTTON_FIRST].SetCheck(true);
		m_DataBuffer[nIDbutton - IDC_BUTTON_FIRST].state = 1;
	}

	WriteDirectOutput(&DeviceList[m_DeviceIndex], m_nPort, m_DataBuffer);
}

void CUSBOUTPUTDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	if(m_pButtons)
		delete [] m_pButtons;	
}
