// USBSPIDACDlg.cpp : implementation file
//

#include "stdafx.h"
#include "USBSPIDAC.h"
#include "USBSPIDACDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

double TotalSteps[] = {255.0, 1023.0, 4095.0, 65535.0, 16777215.0, 4294967295.0};

/////////////////////////////////////////////////////////////////////////////
// CUSBSPIDACDlg dialog

CUSBSPIDACDlg::CUSBSPIDACDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSBSPIDACDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSBSPIDACDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSBSPIDACDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSBSPIDACDlg)
	DDX_Control(pDX, IDC_BINARY11, m_nLevel);
	DDX_Control(pDX, IDC_SLIDER11, m_Level);
	DDX_Control(pDX, IDC_BINARY10, m_Binary10);
	DDX_Control(pDX, IDC_BINARY9, m_Binary9);
	DDX_Control(pDX, IDC_BINARY8, m_Binary8);
	DDX_Control(pDX, IDC_BINARY7, m_Binary7);
	DDX_Control(pDX, IDC_BINARY6, m_Binary6);
	DDX_Control(pDX, IDC_BINARY5, m_Binary5);
	DDX_Control(pDX, IDC_BINARY4, m_Binary4);
	DDX_Control(pDX, IDC_BINARY3, m_Binary3);
	DDX_Control(pDX, IDC_BINARY2, m_Binary2);
	DDX_Control(pDX, IDC_BINARY1, m_Binary1);
	DDX_Control(pDX, IDC_PORT1, m_Port);
	DDX_Control(pDX, IDC_SLIDER9, m_Slider9);
	DDX_Control(pDX, IDC_SLIDER10, m_Slider10);
	DDX_Control(pDX, IDC_COMBO1, m_Combo);
	DDX_Control(pDX, IDC_SLIDER8, m_Slider8);
	DDX_Control(pDX, IDC_SLIDER7, m_Slider7);
	DDX_Control(pDX, IDC_SLIDER6, m_Slider6);
	DDX_Control(pDX, IDC_SLIDER5, m_Slider5);
	DDX_Control(pDX, IDC_SLIDER4, m_Slider4);
	DDX_Control(pDX, IDC_SLIDER3, m_Slider3);
	DDX_Control(pDX, IDC_SLIDER2, m_Slider2);
	DDX_Control(pDX, IDC_SLIDER1, m_Slider1);
	DDX_Control(pDX, IDC_DAC10, m_DAC10);
	DDX_Control(pDX, IDC_DAC9, m_DAC9);
	DDX_Control(pDX, IDC_DAC8, m_DAC8);
	DDX_Control(pDX, IDC_DAC7, m_DAC7);
	DDX_Control(pDX, IDC_DAC6, m_DAC6);
	DDX_Control(pDX, IDC_DAC5, m_DAC5);
	DDX_Control(pDX, IDC_DAC4, m_DAC4);
	DDX_Control(pDX, IDC_DAC3, m_DAC3);
	DDX_Control(pDX, IDC_DAC2, m_DAC2);
	DDX_Control(pDX, IDC_DAC1, m_DAC1);
	DDX_Control(pDX, IDC_DEVICE_LIST, m_DeviceList);
	DDX_Control(pDX, IDC_REFRESH, m_Refresh);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSBSPIDACDlg, CDialog)
	//{{AFX_MSG_MAP(CUSBSPIDACDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_CBN_SELCHANGE(IDC_DEVICE_LIST, OnSelchangeDeviceList)
	ON_WM_CLOSE()
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_CBN_SELCHANGE(IDC_PORT1, OnSelchangePort1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBSPIDACDlg message handlers

BOOL CUSBSPIDACDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_Refresh.SetIcon(theApp.LoadIcon(IDI_JOYSTICK));
	
	m_DeviceList.AddString("No Devices Detected");
	m_DeviceList.SetCurSel(0);
	m_DeviceList.SetItemData(0, 0);

	m_pDeviceInfo = (CEdit *)GetDlgItem(IDC_DEVINFO);

	m_DevCnt = 0;

	memset(&m_DataBuffer, 0, sizeof (m_DataBuffer));
	m_Bits = 0; // default to 8-bits
	m_Combo.SetCurSel(0);
	OnSelchangeCombo1();

	m_Port.SetCurSel(0);
	m_nPort = 0;

	m_Level.SetRange(0, 7);
	m_Level.SetPos(7);
	m_nLevel.SetWindowText("PWM Level: 7");
	
	OnRefresh();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSBSPIDACDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSBSPIDACDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUSBSPIDACDlg::OnRefresh() 
{
	CString str;
	int nIndex;
	UINT DevCntTemp = 0;

	m_DeviceList.ResetContent();

	m_DevCnt = 0;

	// Detect Plasma-Lite V2 + NITRO class devices
	if (DetectDevice(&DevCntTemp, &DeviceList[m_DevCnt], PIDC_PLASMA_LITE_V2, DT_DEVICES)) {
		m_DevCnt += DevCntTemp;
	}

	// Detect NITRO-SLG class devices
	if (DetectDevice(&DevCntTemp, &DeviceList[m_DevCnt], PIDC_NITRO_SLG, DT_HID)) {
		m_DevCnt += DevCntTemp;
	}

	// Detect ElectronFlux class devices
	if (DetectDevice(&DevCntTemp, &DeviceList[m_DevCnt], PIDC_ELECTRONFLUX, DT_HID)) {
		m_DevCnt += DevCntTemp;
	}

	// get all port status data if required
//	for (i = 0; i < m_DevCnt; i++) {
//		RetrieveStatus(&DeviceList[i], &DeviceStatus[i]);
//	}

	if (m_DevCnt == 0) {
		m_pDeviceInfo->SetWindowText(_T("No compatible devices detected!"));
		m_DeviceList.AddString("No Devices Detected");
		m_DeviceList.SetCurSel(0);
		m_DeviceList.SetItemData(0, 0);
	}

	// Add device to combo list.
	for (UINT i = 0; i < m_DevCnt; i++) {
		str.Format("%s - %s", DeviceList[i].DeviceName, DeviceList[i].SerialNum);
		nIndex = m_DeviceList.AddString(str);
		m_DeviceList.SetItemData(nIndex, i);

		// Display Device info
		DeviceInfo(nIndex);
	}

	m_DeviceList.SetCurSel(0);
	m_DeviceIndex = m_DeviceList.GetItemData(0);
}

void CUSBSPIDACDlg::OnSelchangeDeviceList() 
{
	m_DeviceIndex = m_DeviceList.GetItemData(m_DeviceList.GetCurSel());
	if (m_DevCnt > 0)
		DeviceInfo(m_DeviceIndex);
}

void CUSBSPIDACDlg::DeviceInfo(int nIndex)
{
	CString str1, str2, str3, str4, str5, str6, str7;

	// Display Device info
	str1.Format("Device: %d\r\n", nIndex+1);
	str2.Format("  Device Type: %s\r\n", DeviceList[nIndex].DeviceName);
	str3.Format("  Vendor ID: 0x%x\r\n", DeviceList[nIndex].VendorID);
	str4.Format("  Product ID: 0x%x\r\n", DeviceList[nIndex].ProductID);
	str5.Format("  Firmware Version: %d.%d%d\r\n", 
		(((int)(DeviceList[nIndex].VersionNumber & 0xF000)>>12) * 10) + 
		((DeviceList[nIndex].VersionNumber & 0x0F00)>>8),
		(DeviceList[nIndex].VersionNumber & 0x00F0)>>4,
		DeviceList[nIndex].VersionNumber & 0x000F);
	str6.Format("  Serial Num: %s\r\n", DeviceList[nIndex].SerialNum);
	m_pDeviceInfo->SetWindowText(str1 + str2 + str3 + str4 + str5 + str6);
}
void CUSBSPIDACDlg::OnClose() 
{
	if (m_DevCnt > 0)
		CloseDevices(m_DevCnt, DeviceList);
	
	CDialog::OnClose();
}

void CUSBSPIDACDlg::OnSelchangeCombo1() 
{
	// index 0 = 8 bits, 
	// index 1 = 10 bits
	// index 2 = 12 bits
	// index 3 = 16 bits
	// index 4 = 24 bits

	m_Bits = (UCHAR)m_Combo.GetCurSel();

	m_Slider1.SetRange(0, (int)TotalSteps[m_Bits]); 
	m_Slider2.SetRange(0, (int)TotalSteps[m_Bits]);
	m_Slider3.SetRange(0, (int)TotalSteps[m_Bits]);
	m_Slider4.SetRange(0, (int)TotalSteps[m_Bits]);
	m_Slider5.SetRange(0, (int)TotalSteps[m_Bits]); 
	m_Slider6.SetRange(0, (int)TotalSteps[m_Bits]);
	m_Slider7.SetRange(0, (int)TotalSteps[m_Bits]);
	m_Slider8.SetRange(0, (int)TotalSteps[m_Bits]);
	m_Slider9.SetRange(0, (int)TotalSteps[m_Bits]);
	m_Slider10.SetRange(0, (int)TotalSteps[m_Bits]);
}

void CUSBSPIDACDlg::OnSelchangePort1() 
{
	m_nPort = (UCHAR)m_Port.GetCurSel();	
}

void CUSBSPIDACDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CString str;

	switch (pScrollBar->GetDlgCtrlID()) {
		case IDC_SLIDER1: 
			m_DataBuffer.DAC_1 = ((CSliderCtrl *)pScrollBar)->GetPos();
			str.Format("%0.4f V", (((CSliderCtrl *)pScrollBar)->GetPos()/TotalSteps[m_Bits]) * 5.0);
			m_DAC1.SetWindowText(str);
			str.Format("%d", m_DataBuffer.DAC_1);
			m_Binary1.SetWindowText(str);
			break;

		case IDC_SLIDER2:
			m_DataBuffer.DAC_2 = ((CSliderCtrl *)pScrollBar)->GetPos();
			str.Format("%0.4f V", (((CSliderCtrl *)pScrollBar)->GetPos()/TotalSteps[m_Bits]) * 5.0);
			m_DAC2.SetWindowText(str);
			str.Format("%d", m_DataBuffer.DAC_2);
			m_Binary2.SetWindowText(str);
			break;

		case IDC_SLIDER3:
			m_DataBuffer.DAC_3 = ((CSliderCtrl *)pScrollBar)->GetPos();
			str.Format("%0.4f V", (((CSliderCtrl *)pScrollBar)->GetPos()/TotalSteps[m_Bits]) * 5.0);
			m_DAC3.SetWindowText(str);
			str.Format("%d", m_DataBuffer.DAC_3);
			m_Binary3.SetWindowText(str);
			break;

		case IDC_SLIDER4:
			m_DataBuffer.DAC_4 = ((CSliderCtrl *)pScrollBar)->GetPos();
			str.Format("%0.4f V", (((CSliderCtrl *)pScrollBar)->GetPos()/TotalSteps[m_Bits]) * 5.0);
			m_DAC4.SetWindowText(str);
			str.Format("%d", m_DataBuffer.DAC_4);
			m_Binary4.SetWindowText(str);
			break;

		case IDC_SLIDER5:
			m_DataBuffer.DAC_5 = ((CSliderCtrl *)pScrollBar)->GetPos();
			str.Format("%0.4f V", (((CSliderCtrl *)pScrollBar)->GetPos()/TotalSteps[m_Bits]) * 5.0);
			m_DAC5.SetWindowText(str);
			str.Format("%d", m_DataBuffer.DAC_5);
			m_Binary5.SetWindowText(str);
			break;

		case IDC_SLIDER6:
			m_DataBuffer.DAC_6 = ((CSliderCtrl *)pScrollBar)->GetPos();
			str.Format("%0.4f V", (((CSliderCtrl *)pScrollBar)->GetPos()/TotalSteps[m_Bits]) * 5.0);
			m_DAC6.SetWindowText(str);
			str.Format("%d", m_DataBuffer.DAC_6);
			m_Binary6.SetWindowText(str);
			break;

		case IDC_SLIDER7:
			m_DataBuffer.DAC_7 = ((CSliderCtrl *)pScrollBar)->GetPos();
			str.Format("%0.4f V", (((CSliderCtrl *)pScrollBar)->GetPos()/TotalSteps[m_Bits]) * 5.0);
			m_DAC7.SetWindowText(str);
			str.Format("%d", m_DataBuffer.DAC_7);
			m_Binary7.SetWindowText(str);
			break;

		case IDC_SLIDER8:
			m_DataBuffer.DAC_8 = ((CSliderCtrl *)pScrollBar)->GetPos();
			str.Format("%0.4f V", (((CSliderCtrl *)pScrollBar)->GetPos()/TotalSteps[m_Bits]) * 5.0);
			m_DAC8.SetWindowText(str);
			str.Format("%d", m_DataBuffer.DAC_8);
			m_Binary8.SetWindowText(str);
			break;

		case IDC_SLIDER9:
			m_DataBuffer.DAC_9 = ((CSliderCtrl *)pScrollBar)->GetPos();
			str.Format("%0.4f V", (((CSliderCtrl *)pScrollBar)->GetPos()/TotalSteps[m_Bits]) * 5.0);
			m_DAC9.SetWindowText(str);
			str.Format("%d", m_DataBuffer.DAC_9);
			m_Binary9.SetWindowText(str);
			break;

		case IDC_SLIDER10:
			m_DataBuffer.DAC_10 = ((CSliderCtrl *)pScrollBar)->GetPos();
			str.Format("%0.4f V", (((CSliderCtrl *)pScrollBar)->GetPos()/TotalSteps[m_Bits]) * 5.0);
			m_DAC10.SetWindowText(str);
			str.Format("%d", m_DataBuffer.DAC_10);
			m_Binary10.SetWindowText(str);
			break;

		case IDC_SLIDER11:
			str.Format("PWM Level: %d", m_Level.GetPos());
			m_nLevel.SetWindowText(str);
			break;
	}
	
	UCHAR nLevel = (UCHAR)m_Level.GetPos();
	WriteSPIDAC(&DeviceList[m_DeviceIndex], m_nPort, &m_DataBuffer, nLevel);

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
