Attribute VB_Name = "functions"
Option Explicit

Public Function DetectDevices() As Boolean
    Dim i As Integer
    Dim Cnt_Temp As Integer
    Dim retval As Boolean
    Dim str As String

    ' The DetecHID function returns the number "Dev_Cnt" of devices detected
    DetectDevices = False
    Dev_Cnt = 0
    ' Detect Plasma-Lite V2 + NITRO class devices for outputs
    If DetectDevice(Cnt_Temp, DeviceList(0), ID_PLASMA_LITE_V2, DT_DEVICES) Then
        Dev_Cnt = Cnt_Temp + Dev_Cnt
    End If
    
    ' Detect NITRO-SLG class devices for outputs
    If DetectDevice(Cnt_Temp, DeviceList(Dev_Cnt), ID_NITRO_SLG, DT_HID) Then
        Dev_Cnt = Cnt_Temp + Dev_Cnt
    End If
    
    ' Detect ElectronFlux class devices for outputs
    If DetectDevice(Cnt_Temp, DeviceList(Dev_Cnt), ID_ELECTRONFLUX, DT_HID) Then
        Dev_Cnt = Cnt_Temp + Dev_Cnt
    End If
    
    For i = 1 To Dev_Cnt
        ' RetrieveStatus retrieves configuration status of all IO ports.
        ' This call can be used for ElectronFlux modules but will
        ' eventually be used for most other device classes
        'RetrieveStatus DeviceList(i - 1), DeviceStatus(i - 1)
        
        ' add device to combo list
        str = Left(StrConv(DeviceList(i - 1).DeviceName, vbUnicode), DeviceList(i - 1).DeviceNameLength) & " - " & Left(StrConv(DeviceList(i - 1).SerialNum, vbUnicode), DeviceList(i - 1).SerialNumLength)
        frmMain.Combo1.AddItem str
        frmMain.Combo1.ItemData(frmMain.Combo1.NewIndex) = i - 1
    
        Call Display_Info(i - 1)
        DetectDevices = True
    Next
End Function
